<script setup lang="ts">
import { ref } from 'vue'
import type { Header } from "vue3-easy-data-table";
import { notify } from "@kyvg/vue3-notification";
import TaskService from './services/task'
import Task from './interfaces/Task'
import { isToday } from './services/help'

const DEFAULT_TASK = { _id: "", date: new Date(), name: "", description: "" };
const tasks = ref([])
const selectedTask = ref<Task>(DEFAULT_TASK)
const selectedDate = ref<String>()
const action = ref<String>("")

const headers: Header[] = [
  { text: "Date", value: "date", sortable: true},
  { text: "Nom", value: "name"},
  { text: "Description ", value: "description"},
  { text: "Actions", value: "actions"}
];

const notifyTasksToday = () => {
  tasks.value
  .filter((task: Task)=>(isToday(task.date)))
  .forEach((task: Task) => {
    notify({
      title: `La tâche a lieu aujourd'hui !`,
      text: task.name,
      type: 'warn'
    })
  })
}

const getTasks = (init: boolean = false) => {
  TaskService.getTasks().then(res => {
    tasks.value = res.data.map((task: any) => {
      task.date = new Date(Number(task.date.$date.$numberLong));
      return task;
    })

    if (init === true)
      notifyTasksToday()
  })
}

const openModal = (task?: Task) => {
  if (task?._id) {
    action.value="updating"
    selectedDate.value = task.date.toISOString().split('T')[0]
    selectedTask.value = task
  } else {
    action.value="adding"
    selectedTask.value = {...DEFAULT_TASK}
    selectedDate.value = new Date().toISOString().split('T')[0]
  }
}

const modalSubmit = () => {
  if (action.value === 'adding') {
    addTask(selectedTask.value)
  } else {
    editTask(selectedTask.value);
  }
}

const addTask = (task: any) => {
  TaskService.addTask({ ...task, date: selectedDate.value }).then(() => {
    notify({
      title: `La tâche a été ajoutée`,
      type: 'success'
    })
    getTasks();
  });
}

const editTask = (task: any) => {
  TaskService.updateTask({ ...task, date: selectedDate.value }).then(() => {
    notify({
      title: `La tâche a été mise à jour`,
      type: 'success'
    })
    getTasks();
  });
}

const removeTask = (task: any) => {
  TaskService.removeTask( task._id ).then(() => {
    notify({
      title: `La tâche ${task.name} a été supprimée`,
      type: 'error'
    })
    getTasks();
  });
}

getTasks(true)
</script>

<template>
      <div class="header-wrapper mb-1">
        <h1> Liste de tâches</h1>
        <button class="btn btn-primary" data-bs-toggle="modal" data-bs-target="#taskModal"
         @click="openModal()">
         Ajouter une tâche
        </button>
      </div>
  
      <EasyDataTable
      :headers="headers"
      :items="tasks"
      :rows-per-page-message="'Tâches par page'">
      <template #item-date="item">
        {{ new Intl.DateTimeFormat(['fr-FR']).format(item.date) }}
      </template>
      <template #item-actions="item">
      <div class="actions-wrapper">
          <a href="#" data-bs-toggle="modal" data-bs-target="#taskModal" @click="openModal(item)">
            Modifier
          </a>&nbsp;
          <a href="#" @click="removeTask(item)">Supprimer</a>
        </div>
      </template>
      </EasyDataTable>


<!-- Modal -->
<div class="modal fade" id="taskModal" tabindex="-1" aria-labelledby="taskModalLabel" aria-hidden="true">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="taskModalLabel">Modifier la tâche</h5>
      </div>
      <div class="modal-body">
        <form @submit.prevent="modalSubmit">
          <input type="date" v-model="selectedDate" />
          <input autofocus class="form-control mt-2" type="text" v-model="selectedTask.name" />
          <textarea class="form-control mt-2" type="text" v-model="selectedTask.description" />
          <div class="align-r mt-2">
            <button type="button" class="btn btn-secondary ml-1" data-bs-dismiss="modal">Annuler</button>
            <button type="submit" class="btn btn-primary ml-1" data-bs-dismiss="modal">
              {{action==='adding'?'Ajouter':'Modifier'}}
            </button>
          </div>
        </form>
      </div>
    </div>
  </div>
</div>

<notifications />
</template>

<style scoped type="scss">
  .header-wrapper {
    display: flex;
    justify-content: space-between;
    align-items: center;
  }

  .align-r {
    display: flex;
    justify-content: end;
  }

  .ml-1 {
    margin-left: 10px;
  }
</style>
